"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSurveyInstructions = void 0;

var _Status = _interopRequireDefault(require("../Status"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getSurveyInstructions = async ({
  uri
}) => {
  try {
    const res = await fetch(uri, {
      method: 'GET'
    });

    const checkd = _Status.default.checkStatus(res);

    const json = await checkd.json();
    return json;
  } catch (err) {
    console.log('Survey instruction Error', err);
    throw new Error(err.message);
  }
};

exports.getSurveyInstructions = getSurveyInstructions;
//# sourceMappingURL=surveyInstructions.js.map