"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNavigation = require("react-navigation");

var _reactNavigationStack = require("react-navigation-stack");

var _PI = _interopRequireDefault(require("./PI"));

var _Success = _interopRequireDefault(require("./common/Success"));

var _WithOutQuote = _interopRequireDefault(require("./common/WithOutQuote"));

var _DocumentCollection = _interopRequireDefault(require("./common/DocumentCollection"));

var _QuoteInstructions = _interopRequireDefault(require("./common/QuoteInstructions"));

var _Camera = _interopRequireDefault(require("./common/Camera"));

var _PreviewImage = _interopRequireDefault(require("./common/PreviewImage"));

var _VideoRecorder = _interopRequireDefault(require("./common/VideoRecorder"));

var _VideoPreview = _interopRequireDefault(require("./common/VideoPreview"));

var _DocumentUpload = _interopRequireDefault(require("./common/DocumentUpload"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _store = _interopRequireDefault(require("./redux/store"));

var _Colors = _interopRequireDefault(require("./common/Colors"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

//AppNAvigator
const AppNavigator = (0, _reactNavigationStack.createStackNavigator)({
  Success: {
    screen: _Success.default,
    navigationOptions: {
      headerShown: false
    }
  },
  WithOutQuote: {
    screen: _WithOutQuote.default,
    navigationOptions: {
      headerShown: false
    }
  },
  DocumentCollection: {
    screen: _DocumentCollection.default,
    navigationOptions: {
      headerShown: false
    }
  },
  // QuoteInstructions: { screen: QuoteInstructions, navigationOptions: { headerTitle: '', headerTintColor: Colors.darkBlack, headerStyle: { backgroundColor: Colors.lightBlack } } },
  QuoteInstructions: {
    screen: _QuoteInstructions.default,
    navigationOptions: {
      headerShown: false
    }
  },
  PI: {
    screen: _PI.default,
    navigationOptions: {
      headerShown: false
    }
  },
  Camera: {
    screen: _Camera.default,
    navigationOptions: {
      headerShown: false
    }
  },
  PreviewImage: {
    screen: _PreviewImage.default,
    navigationOptions: {
      headerShown: false
    }
  },
  VideoRecorder: {
    screen: _VideoRecorder.default,
    navigationOptions: {
      headerShown: false
    }
  },
  VideoPreview: {
    screen: _VideoPreview.default,
    navigationOptions: {
      headerShown: false
    }
  },
  DocumentUpload: {
    screen: _DocumentUpload.default,
    navigationOptions: {
      headerShown: false
    }
  }
}, {
  initialRouteName: "PI" //To Render From Here

});
const AppContainer = (0, _reactNavigation.createAppContainer)(AppNavigator);

class App extends _react.Component {
  render() {
    console.log(this.props.activityId);
    return /*#__PURE__*/_react.default.createElement(_reactRedux.Provider, {
      store: _store.default
    }, /*#__PURE__*/_react.default.createElement(AppContainer, {
      screenProps: {
        activityId: this.props.activityId,
        activityTypeId: this.props.activityTypeId,
        webUserId: this.props.webUserId,
        props: this.props
      }
    }));
  }

}

App.propTypes = {
  activityId: _propTypes.default.string,
  activityTypeId: _propTypes.default.string,
  webUserId: _propTypes.default.string
};
App.defaultProps = {
  activityId: '-1',
  activityTypeId: '-1',
  webUserId: '-1'
};
var _default = App;
exports.default = _default;
//# sourceMappingURL=index.js.map