"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _redux = require("redux");

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _uploadImageDatasourceReducer = _interopRequireDefault(require("./reducers/uploadImageDatasourceReducer"));

var _sensorDataReducer = _interopRequireDefault(require("./reducers/sensorDataReducer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 
 *
 * This file configures the Redux store
 *
 * To keep things simple, and because Firebase already acts as a state management solution,
 * we are only using Redux for the following:
 *
 * 1) `redux-form` integration
 * 2) Basic UI state, i.e. the loading modal
 */
const appReducer = (0, _redux.combineReducers)({
  UploadImageData: _uploadImageDatasourceReducer.default,
  SensorData: _sensorDataReducer.default
});

const rootReducer = (state, action) => appReducer(state, action);

const store = (0, _redux.createStore)(rootReducer, (0, _redux.applyMiddleware)(_reduxThunk.default));
var _default = store;
exports.default = _default;
//# sourceMappingURL=store.js.map