const PROD = true;
const PRE_PROD = false;
const UAT = false; // do not change this flag, if above both flags are false then app will connect to UAT
const PROD_BASE = {
  INSTRUCTIONS: "https://prod-commondataservice.godigit.com/",
  SELF_SURVEY_SERVICES: "https://prod-selfsurveyservices.godigit.com/",
  COMMON_DATA_SERVICE: "https://prod-commondataservice.godigit.com/",
};

const UAT_BASE = {
  INSTRUCTIONS: "https://uat-commondataservice.godigit.com/",
  SELF_SURVEY_SERVICES: "https://uat-selfsurveyservices.godigit.com/",
  COMMON_DATA_SERVICE: "https://uat-commondataservice.godigit.com/",
};

const PREPROD_BASE = {
  INSTRUCTIONS: "https://preprod-commondataservice.godigit.com/",
  SELF_SURVEY_SERVICES: "https://preprod-selfsurveyservices.godigit.com/",
  COMMON_DATA_SERVICE: "https://preprod-commondataservice.godigit.com/",
};

const BASE_URL = PROD ? PROD_BASE : PRE_PROD ? PREPROD_BASE : UAT_BASE;

const INSTRUCTIONS_URL =
  BASE_URL.INSTRUCTIONS + "CommonDataService/rest/survey/instructions/";
const SELFSURVEYSERVICE_DOCUMENT_URL =
  BASE_URL.SELF_SURVEY_SERVICES + "SelfSurveyServices/document";
const AGENT_DATA =
  BASE_URL.COMMON_DATA_SERVICE +
  "CommonDataService/rest/GetWebUsers?webUserId=35327650";
const POSE_DETECTION =
  BASE_URL.SELF_SURVEY_SERVICES + "SelfSurveyServices/detectPose";
const CHASSSIS_POSE_DETECTION =
  BASE_URL.SELF_SURVEY_SERVICES +
  "SelfSurveyServices/detect/chassis-plate/text";
const DOCUMENT_LAST =
  BASE_URL.SELF_SURVEY_SERVICES + "SelfSurveyServices/document/last";
const SELF_SURVEY_SERVICES_ACTIVITYID =
  BASE_URL.SELF_SURVEY_SERVICES + "SelfSurveyServices/";
const SUBMITPI_URL =
  BASE_URL.SELF_SURVEY_SERVICES + "SelfSurveyServices/submitPI";

export {
  PROD,
  PRE_PROD,
  UAT,
  INSTRUCTIONS_URL,
  SELFSURVEYSERVICE_DOCUMENT_URL,
  AGENT_DATA,
  POSE_DETECTION,
  CHASSSIS_POSE_DETECTION,
  DOCUMENT_LAST,
  SELF_SURVEY_SERVICES_ACTIVITYID,
  SUBMITPI_URL,
};
