import { StyleSheet } from 'react-native';
import Colors from '../common/Colors';
import { SCREEN_WIDTH } from '../common/Constants'

const style = StyleSheet.create({
    mainStyle: {
        flex: 1,
        backgroundColor: Colors.white
    },
    muliboldBB: {
        fontFamily: 'Muli-Bold',
        color: Colors.borderBlack,
    },
    muliBoldVRG: {
        fontFamily: 'Muli-Bold',
        textTransform: 'uppercase',
        fontWeight: 'bold',
        color: Colors.veryLightGray,
    },
    muliRegLG: {
        fontFamily: 'Muli-Regular',
        color: Colors.veryLightGray,
        fontWeight: 'bold'
    },
    muliRegLGWOB: {
        fontFamily: 'Muli-Regular',
        color: Colors.veryLightGray,
    },
    muliBoldLGWOB: {
        fontFamily: 'Muli-Bold',
        color: Colors.veryLightGray,
    },
    muliRegDB: {
        fontFamily: 'Muli-Regular',
        color: Colors.darkBlack
    },
    muliBoldDB: {
        fontFamily: 'Muli-Bold',
        color: Colors.darkBlack
    },
    muliExBoldDB: {
        fontFamily: 'Muli-ExtraBold',
        color: Colors.darkBlack
    },
    errorText: {
        fontFamily: 'Muli-Regular',
        fontSize: 14,
        color: '#DD1111',
        // marginTop: 3,
    },
    allMargin24: {
        marginTop: 24,
        marginLeft: 24,
        marginRight: 24
    },
    marginLR24: {
        marginLeft: 24,
        marginRight: 24
    },
    motorListHeadOut: {
        flexDirection: 'row',
        height: 48,
        marginLeft: 24,
        marginTop: 12,
        marginRight: 16,
        borderWidth: 1,
        borderRadius: 4,
        backgroundColor: '#FFFFFF',
        alignItems: 'center'
    },
    leftArrowImageStyle: {
        height: 12,
        marginLeft: 8
    },
    borderBottomStyle: {
        width: SCREEN_WIDTH - 50,
        alignSelf: 'center',
        borderColor: Colors.lightGray,
        borderBottomWidth: 1,
    },
});

export default style;